%global debug_package %{nil}

# enable more stripping. This was failing on cisco wrlinux and AIX. We may want
# to get this worked out eventually, but for now let's just skip these for
# those platforms
%global __debug_package %{nil}
# to resolve: "ERROR: No build ID note found"
%undefine _missing_build_ids_terminate_build
# To avoid files installed but not packaged errors
%global __os_install_post %{__os_install_post} \
 rm -rf %{buildroot}/usr/lib/debug

# Turn off the brp-python-bytecompile script
%global __os_install_post %(echo '%{__os_install_post}' | sed -e 's!/usr/lib[^[:space:]]*/brp-python-bytecompile[[:space:]].*$!!g')

Name: pe-nginx
Version: 2018.1.1.14.0
Release: 1.pe%{?dist}
Summary: Puppet Enterprise uses the nginx HTTP Server. nginx is an HTTP and reverse proxy server.
Vendor: Puppet Labs
License: 2-clause BSD-like license
Group: System Environment/Base
URL: https://www.puppetlabs.com

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

Source0: %{name}-%{version}.tar.gz
Source1: file-list-for-rpm

# Don't provide anything so the system doesn't use our packages to resolve deps
Autoprov: 0
Autoreq: 0
Requires: puppet-agent
Requires: pe-puppet-enterprise-release

# All rpm packages built by vanagon have the pre-/post-install script
# boilerplates (defined below). These require `mkdir` and `touch` but previously
# did not specify a dependency on these.
# In the future, we will supress pre/post scripts completely if there's nothing
# specified by the project or the components.
Requires(pre): /bin/mkdir
Requires(pre): /bin/touch
Requires(post): /bin/mkdir
Requires(post): /bin/touch

Requires: chkconfig

Obsoletes: pe-httpd
Obsoletes: pe-libapr
Obsoletes: pe-libaprutil

Provides: pe-webserver

%description
Puppet Enterprise uses the nginx HTTP Server. nginx is an HTTP and reverse proxy server.

Contains the following components:
pe-nginx 

%prep
%setup -q -n %{name}-%{version}

%build

%clean

%install
test -d /opt/freeware/bin && export PATH="/opt/freeware/bin:${PATH}"
rm -rf %{buildroot}
install -d %{buildroot}

# Copy each directory into place. Because empty directories won't make it into.
 if [ -d opt/puppetlabs/server/apps/nginx ]; then
 install -d %{buildroot}/opt/puppetlabs/server/apps
 cp -pr opt/puppetlabs/server/apps/nginx %{buildroot}/opt/puppetlabs/server/apps
 else
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx
 fi
 if [ -d etc/puppetlabs/nginx ]; then
 install -d %{buildroot}/etc/puppetlabs
 cp -pr etc/puppetlabs/nginx %{buildroot}/etc/puppetlabs
 else
 install -d %{buildroot}/etc/puppetlabs/nginx
 fi
 if [ -d etc/puppetlabs/nginx/conf.d ]; then
 install -d %{buildroot}/etc/puppetlabs/nginx
 cp -pr etc/puppetlabs/nginx/conf.d %{buildroot}/etc/puppetlabs/nginx
 else
 install -d %{buildroot}/etc/puppetlabs/nginx/conf.d
 fi
 if [ -d opt/puppetlabs/server/apps/nginx/share ]; then
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx
 cp -pr opt/puppetlabs/server/apps/nginx/share %{buildroot}/opt/puppetlabs/server/apps/nginx
 else
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx/share
 fi
 if [ -d var/cache/puppetlabs/nginx ]; then
 install -d %{buildroot}/var/cache/puppetlabs
 cp -pr var/cache/puppetlabs/nginx %{buildroot}/var/cache/puppetlabs
 else
 install -d %{buildroot}/var/cache/puppetlabs/nginx
 fi
 if [ -d var/log/puppetlabs/nginx ]; then
 install -d %{buildroot}/var/log/puppetlabs
 cp -pr var/log/puppetlabs/nginx %{buildroot}/var/log/puppetlabs
 else
 install -d %{buildroot}/var/log/puppetlabs/nginx
 fi
 if [ -d var/run/puppetlabs/nginx ]; then
 install -d %{buildroot}/var/run/puppetlabs
 cp -pr var/run/puppetlabs/nginx %{buildroot}/var/run/puppetlabs
 else
 install -d %{buildroot}/var/run/puppetlabs/nginx
 fi
 if [ -d opt/puppetlabs/server/apps/nginx/share/client_temp ]; then
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx/share
 cp -pr opt/puppetlabs/server/apps/nginx/share/client_temp %{buildroot}/opt/puppetlabs/server/apps/nginx/share
 else
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx/share/client_temp
 fi
 if [ -d opt/puppetlabs/server/apps/nginx/share/proxy_temp ]; then
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx/share
 cp -pr opt/puppetlabs/server/apps/nginx/share/proxy_temp %{buildroot}/opt/puppetlabs/server/apps/nginx/share
 else
 install -d %{buildroot}/opt/puppetlabs/server/apps/nginx/share/proxy_temp
 fi

# Copy each of the extra files into place
 install -d %{buildroot}/opt/puppetlabs/server/bin
 cp -Rp opt/puppetlabs/server/bin/nginx %{buildroot}/opt/puppetlabs/server/bin
 install -d %{buildroot}/usr/lib/tmpfiles.d
 cp -Rp usr/lib/tmpfiles.d/pe-nginx.conf %{buildroot}/usr/lib/tmpfiles.d
 install -d %{buildroot}/etc/rc.d/init.d
 cp -Rp etc/rc.d/init.d/pe-nginx %{buildroot}/etc/rc.d/init.d
 install -d %{buildroot}/etc/puppetlabs/nginx
 cp -Rp etc/puppetlabs/nginx/nginx.conf %{buildroot}/etc/puppetlabs/nginx
 install -d %{buildroot}/etc/logrotate.d
 cp -Rp etc/logrotate.d/pe-nginx %{buildroot}/etc/logrotate.d
 install -d %{buildroot}/etc/puppetlabs/nginx
 cp -Rp etc/puppetlabs/nginx/koi-utf %{buildroot}/etc/puppetlabs/nginx
 install -d %{buildroot}/etc/puppetlabs/nginx
 cp -Rp etc/puppetlabs/nginx/koi-win %{buildroot}/etc/puppetlabs/nginx
 install -d %{buildroot}/etc/puppetlabs/nginx
 cp -Rp etc/puppetlabs/nginx/win-utf %{buildroot}/etc/puppetlabs/nginx
 install -d %{buildroot}/etc/puppetlabs/nginx
 cp -Rp etc/puppetlabs/nginx/mime.types %{buildroot}/etc/puppetlabs/nginx
 install -d %{buildroot}/etc/sysconfig
 cp -Rp etc/sysconfig/pe-nginx %{buildroot}/etc/sysconfig

# Here we explicitly remove the directories and files that we list in the
# %files section separately because rpm3 on aix errors on duplicate files in
# the package.
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/opt/puppetlabs/server/apps/nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx/conf.d$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/opt/puppetlabs/server/apps/nginx/share$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/var/cache/puppetlabs/nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/var/log/puppetlabs/nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/var/run/puppetlabs/nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/opt/puppetlabs/server/apps/nginx/share/client_temp$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/opt/puppetlabs/server/apps/nginx/share/proxy_temp$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/opt/puppetlabs/server/bin/nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/usr/lib/tmpfiles.d/pe-nginx.conf$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/rc.d/init.d/pe-nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx/nginx.conf$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/logrotate.d/pe-nginx$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx/koi-utf$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx/koi-win$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx/win-utf$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/puppetlabs/nginx/mime.types$||g' %{SOURCE1}
 PATH=/opt/freeware/bin:$PATH sed -i 's|^/etc/sysconfig/pe-nginx$||g' %{SOURCE1}

# Here we turn all dirs in the file-list into %dir entries to avoid duplicate files
while read entry; do
 if [ -n "$entry" -a -d "$entry" -a ! -L "$entry" ]; then
 sed -i "\|^$entry\$|s|^|%dir |" %{SOURCE1}
 fi
done < %{SOURCE1}

%pre
# Save state so we know later if this is an upgrade or an install
mkdir -p %{_localstatedir}/lib/rpm-state/%{name}
if [ "$1" -eq 1 ] ; then
 touch %{_localstatedir}/lib/rpm-state/%{name}/install
fi
if [ "$1" -gt 1 ] ; then
 touch %{_localstatedir}/lib/rpm-state/%{name}/upgrade
fi

# Add our user and group
if getent group 'pe-webserver' > /dev/null 2>&1; then
 /usr/sbin/groupmod 'pe-webserver'
else
 /usr/sbin/groupadd --system 'pe-webserver'
fi

if getent passwd 'pe-webserver' > /dev/null 2>&1; then
 /usr/sbin/usermod --gid 'pe-webserver' --shell '/sbin/nologin' --home '/var/cache/puppetlabs/nginx' 'pe-webserver'
else
 /usr/sbin/useradd --system --gid 'pe-webserver' --shell '/sbin/nologin' --home '/var/cache/puppetlabs/nginx' 'pe-webserver'
fi

# Run preinstall scripts on install if defined
if [ "$1" -eq 1 ] ; then
 : no preinstall scripts provided
fi

# Run preinstall scripts on upgrade if defined
if [ "$1" -gt 1 ] ; then
 : no preinstall scripts provided
fi

%post
 # switch based on systemd vs systemv vs smf vs aix
 #
 chkconfig --add pe-nginx >/dev/null 2>&1 || :

%triggerpostun -- pe-nginx

%postun
# Run post-uninstall scripts on upgrade if defined
if [ "$1" -eq 1 ] ; then
 : no postremove scripts provided
fi

# Run post-uninstall scripts on removal if defined
if [ "$1" -eq 0 ] ; then
 : no postremove scripts provided
fi

 # switch based on systemd vs systemv vs smf vs aix
 #
 if [ "$1" -eq 1 ]; then
 /sbin/service pe-nginx condrestart || :
 fi

%preun
# Run pre-uninstall scripts on upgrade if defined
if [ "$1" -eq 1 ] ; then
 : no preremove scripts provided
fi

# Run pre-uninstall scripts on removal if defined
if [ "$1" -eq 0 ] ; then
 : no preremove scripts provided
fi

 if [ "$1" -eq 0 ]; then
 /sbin/service pe-nginx stop >/dev/null 2>&1 || :
 chkconfig --del pe-nginx || :
 fi

%posttrans
# Run post-transaction scripts on install if defined
if [ -e %{_localstatedir}/lib/rpm-state/%{name}/install ] ; then
 for file in /var/log/puppetlabs/nginx/access.log /var/log/puppetlabs/nginx/error.log; do
 touch $file ||:
 chown pe-webserver:pe-webserver $file ||:
 chmod 640 $file ||:
done

 rm %{_localstatedir}/lib/rpm-state/%{name}/install
fi

# Run post-transaction scripts on upgrade if defined
if [ -e %{_localstatedir}/lib/rpm-state/%{name}/upgrade ] ; then
 for file in /var/log/puppetlabs/nginx/access.log /var/log/puppetlabs/nginx/error.log; do
 touch $file ||:
 chown pe-webserver:pe-webserver $file ||:
 chmod 640 $file ||:
done

 rm %{_localstatedir}/lib/rpm-state/%{name}/upgrade
fi

%files -f %{SOURCE1}
%doc bill-of-materials
%defattr(-, root, root, 0755)
%dir %attr(-, -, -) /opt/puppetlabs/server/apps/nginx
%dir %attr(-, -, -) /etc/puppetlabs/nginx
%dir %attr(-, -, -) /etc/puppetlabs/nginx/conf.d
%dir %attr(-, -, -) /opt/puppetlabs/server/apps/nginx/share
%dir %attr(0755, -, -) /var/cache/puppetlabs/nginx
%dir %attr(0755, pe-webserver, pe-webserver) /var/log/puppetlabs/nginx
%dir %attr(0755, pe-webserver, pe-webserver) /var/run/puppetlabs/nginx
%dir %attr(-, -, -) /opt/puppetlabs/server/apps/nginx/share/client_temp
%dir %attr(-, -, -) /opt/puppetlabs/server/apps/nginx/share/proxy_temp
%config(noreplace) %attr(0644, -, -) /etc/puppetlabs/nginx/nginx.conf
%config(noreplace) %attr(0644, -, -) /etc/logrotate.d/pe-nginx
%config(noreplace) %attr(0644, -, -) /etc/puppetlabs/nginx/koi-utf
%config(noreplace) %attr(0644, -, -) /etc/puppetlabs/nginx/koi-win
%config(noreplace) %attr(0644, -, -) /etc/puppetlabs/nginx/win-utf
%config(noreplace) %attr(0644, -, -) /etc/puppetlabs/nginx/mime.types
%config(noreplace) %attr(-, -, -) /etc/sysconfig/pe-nginx
%attr(-, -, -) /opt/puppetlabs/server/bin/nginx
%attr(0644, -, -) /usr/lib/tmpfiles.d/pe-nginx.conf
%attr(0755, -, -) /etc/rc.d/init.d/pe-nginx

%changelog
* Tue Jul 03 2018 Puppet Labs <info@puppetlabs.com> - 2018.1.1.14.0-1.pe
- Build for 2018.1.1.14.0-1.pe
